CON
   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000
  
VAR
  long  scale
  long  size

OBJ
  lcd : "Nokia6100"
  SID : "SIDCog"
  
PUB start | r,s,m,n,p,q,u,v,i, j, a, b, c, d, dx, dy, x, y, color, xz, yz, tm

  SID.start
  SID.setFilterType(false,false,false)
  SID.setFilterMask(false,false,false)
  SID.setWaveform(0,2)
  SID.setPWM(0,1928)
  SID.setADSR(0,2,5,9,6)
  SID.setWaveform(1,3)  
  SID.setADSR(1,0,8,4,7)
  SID.setWaveform(2,1)
  SID.setADSR(2,7,4,8,9)
  SID.setVolume(10)

  lcd.start(4, 5, 6, 7, lcd#EPSON)
  lcd.background(lcd#BLACK)  
  lcd.color(lcd#WHITE)
  lcd.clear

  tm:=0

  scale:=1<<20
  x:=scale*355/113   
  y:=scale*355/113

  repeat
    a:=a+1
    i:=x
    x:=scale-y+||x
    y:=i

    color++

    if color >500
     color:=0
      lcd.clear

    xz:= 60+(-(x*10/scale)+90)/4
    yz:= 60+(-(y*10/scale)+90)/2

    lcd.plot(-(x*10/scale)+90,-(y*10/scale)+90)

    tm++

    if tm>250
      tm:=0
      SID.noteOn(0,note2freq(xz))
      waitcnt(cnt + (xz/4)*clkfreq/yz)
      SID.noteOff(0)

PUB note2freq(note) | octave
    octave := note/12
    note -= octave*12 
    return (noteTable[note]>>(8-octave))

DAT
noteTable word 16350, 17320, 18350, 19450, 20600, 21830, 23120, 24500, 25960, 27500, 29140, 30870
                                           